/* Programme demo pour l'utilisation d'un smaphore et d'une memoire partagee
   Prise et liberation d'un smaphore lmentaire par un processus et son fils
   sem_shm_demo.C  
*/
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include "semaphor.h"
#include "sharemem.h"
#include <sys/unistd.h>
#include <fcntl.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "enplus.h"

#define   CLE_SEM1 414
#define   CLE_SEM2 413
#define   CLE_SEM3 412
#define CLE_MEM 415
#define CLE_MEM2 416

#define RAND_MAX 15

int nb_lecteurs;
int mutex, memid,memid2;
int lect_ecr,ecr;
char *share_buf;
char *share_var;
pid_t pid1,pid2,pid3;
char *temp=new char[100];

/*fonction traitant le cas d'une interruption  de programme avec CTRL C */
void inter()
{
  /*envoi d'une interruption au fils */
  //kill (SIGINT, pid);
}

void lecteur(char* i){
  while(1){
    cout<<"Demande de la part du lecteur "<<i<<"\n";
    P(lect_ecr);

    P(mutex);
    lire(share_var,temp);
    nb_lecteurs=atoi(temp);
    nb_lecteurs++;
    itoa((long)nb_lecteurs,temp);
    ecrire(share_var,temp);
    cout<<"Lecteur "<<i<<" - debut de lecture\n";

    V(mutex);

    //lire
    cout<<"Lecteur "<<i<<" - lecture memoire partagee :"<< share_buf<<"\n   nb_lecteurs = "<<nb_lecteurs<<"\n";
    sleep(5);

    P(mutex);
    lire(share_var,temp);
    nb_lecteurs=atoi(temp);
    nb_lecteurs--;
    itoa((long)nb_lecteurs,temp);
    ecrire(share_var,temp);
    cout<<"Lecteur   "<<i<<" - fin de lecture\n";
 
    V(mutex);
    V(lect_ecr);
    sleep(1);
  }
}

void redacteur(char* i){
  while(1){
    cout<<"Demande de la part du redacteur "<<i<<"\n";
     P(ecr);
     P(lect_ecr);P(lect_ecr);P(lect_ecr);
   
    strcpy(temp,"je suis le redacteur ");
    strcat(temp,i);
    cout<<"Redacteur "<<i<<" - debut d'criture\n";
    ecrire(share_buf, temp);
    sleep(5);
    lire(share_var, temp);
    nb_lecteurs=atoi(temp);
    cout<<"Redacteur "<<i<<" - ecriture memoire partagee :"<<share_buf<<"\n   nb_lecteurs="<<nb_lecteurs<<"\n";
    cout<<"Redacteur "<<i<<" - fin d'criture\n";
   
    V(lect_ecr); V(lect_ecr); V(lect_ecr);
    V(ecr);
    sleep(10);
  }
}

main()
{
/* creation du semaphore mutex */
mutex = creesem(CLE_SEM1, 1);
/*creation du semaphore lect_ecr */
lect_ecr= creesem(CLE_SEM2, 3);
/*creation du semaphore ecr */
ecr= creesem(CLE_SEM3, 1);


/* creation des  mmoires partagees */
share_buf= (char *)creemem(CLE_MEM, 20, memid);
share_var= (char *)creemem(CLE_MEM2, 20, memid2);

ecrire(share_var,"0");


 pid1=fork();
 pid2=fork();
 pid3=fork();// dsormais on dispose de 8 processus


 if( pid1 && pid2 && pid3){
   lecteur("1");
 }
 if( pid1 && pid2 && !pid3){
   lecteur("2");
 }
 if( pid1 && !pid2 && pid3){
   lecteur("3");
 }
 if( !pid1 && pid2 && pid3){
   redacteur("1");
 }
 if( !pid1 && pid2 && !pid3){
   redacteur("2");
 }

 sleep(20);

 if (pid1 && pid2 && pid3){// pre supreme
   /* destruction des semaphores */
  detruisem(mutex);
  detruisem(lect_ecr);
  detruisem(ecr);
  /* destruction et detachement d une  memoire partagee*/
  detach(share_buf,memid);
  detach(share_buf,memid2);
 }

 exit(0);

}


